function ADMRCGA( ProblemFunction)


if ~exist('ProblemFunction', 'var') || isempty(ProblemFunction)
    ProblemFunction = @F1;
end
% ____________________________ Define Varible _____________________________

[OPTIONS.InitFunction, OPTIONS.CostFunction] =ProblemFunction() ;
OPTIONS.MaxFEval = 1000;
OPTIONS.MinCost = -9999999;

OPTIONS.popsize = 100;
OPTIONS.numVar = 30;

OPTIONS.selection = 0.80;
OPTIONS.cross = 0.8;

iteration = 1;
alpha = 0.25;
Ymin = zeros(1, OPTIONS.numVar);
Ymax = zeros(1, OPTIONS.numVar);
l = zeros(1, OPTIONS.numVar);
BestArray = zeros(1,OPTIONS.MaxFEval);
AverageArray = zeros(1,OPTIONS.MaxFEval);
victorPopulation = zeros(1,OPTIONS.popsize);

% _____________________ Create The Initial Population _____________________

[Population, OPTIONS] = OPTIONS.InitFunction(OPTIONS);

OPTIONS.popkeep = floor(OPTIONS.selection * OPTIONS.popsize);
OPTIONS.pdirect =  OPTIONS.popsize - OPTIONS.popkeep;
OPTIONS.popCross = 2 * round((OPTIONS.popsize * OPTIONS.cross) / 2);
OPTIONS.numCross = (OPTIONS.popCross / 2);


ma = zeros(1, OPTIONS.numCross);
da = zeros(1, OPTIONS.numCross);

Population = OPTIONS.CostFunction(Population, OPTIONS);

PopulationDirect = struct(Population(1));
PopulationCross = struct(Population(1));
PopulationADM = struct(Population(1));

[PopulationPrevious1, OPTIONS] = OPTIONS.InitFunction(OPTIONS);
PopulationPrevious1 = OPTIONS.CostFunction(PopulationPrevious1, OPTIONS);

[PopulationPrevious2, OPTIONS] = OPTIONS.InitFunction(OPTIONS);
PopulationPrevious2 = OPTIONS.CostFunction(PopulationPrevious2, OPTIONS);


% mean contains mean of population

% _____________________________ GSA main body _____________________________

while(iteration < OPTIONS.MaxFEval)
    iteration = iteration + 1;
    
    [sortpop,indpop] = sort([Population.cost]);
    for s = 1 : OPTIONS.popsize
        Population(s) = Population(indpop(s));
    end
    BestArray(iteration) = min(sortpop);
    AverageArray(iteration) = mean(sortpop);
    disp(num2str(BestArray(iteration)));
    
    % Direct Population *****************************************
    for d=1:OPTIONS.pdirect
        PopulationDirect(d) = Population(d);
    end
    
    % Select Process ********************************************
    maRand = rand(1,OPTIONS.numCross);
    daRand = rand(1,OPTIONS.numCross);
    prob = flipud((1:OPTIONS.popCross)'/sum(1:OPTIONS.popCross));
    cm = [0 cumsum(prob(1:OPTIONS.popCross))'];
    
     
    for ic = 1 : OPTIONS.numCross
        for id = 2 : OPTIONS.popCross + 1
            if maRand(ic) <= cm(id) && maRand(ic) > cm(id-1)
                ma(ic)=id-1;
            end
            if daRand(ic) <= cm(id) && daRand(ic) > cm(id-1)
                da(ic)=id-1;
            end
        end
    end
    
    % CrossOver Process ****************************************
    j = -1;
    for i = 1 : OPTIONS.numCross
        j = j + 2;
        Pop1 = Population(ma(i));
        Pop2 = Population(da(i));
        
        for i8 = 1 : OPTIONS.numVar
            Ymin(i8) = min(Pop1.chrom(i8), Pop2.chrom(i8));
            Ymax(i8) = max(Pop1.chrom(i8), Pop2.chrom(i8));
            l(i8) = abs(Pop1.chrom(i8) - Pop2.chrom(i8));
        end
        for j8 = 1 : OPTIONS.numVar
            offspring1(j8) = Ymin(j8) - (alpha * l(j8));
            offspring2(j8) = Ymax(j8) + (alpha * l(j8));
        end
        
        PopulationCross(j).chrom = [offspring1];
        PopulationCross(j + 1).chrom = [offspring2];
    end
    PopulationCross = OPTIONS.CostFunction(PopulationCross, OPTIONS);
    
    
    % Mutation Process ***************************************
    k = 0;
    for ii = 0 : 2 : OPTIONS.popkeep - 2
        k = k + 1;
        randOffspring = randi(2);
        if randOffspring ~= 1
            iii = ii + 1;
            PopulationADM(k).chrom = PopulationCross(iii).chrom;
            k = k + 1;
        else
            iii = ii + 2;
            PopulationADM(k).chrom = PopulationCross(iii).chrom;
            k = k + 1;
        end
        iii = ii + randOffspring;
        for m = 1 : OPTIONS.popsize
            victorPopulation(m) = Population(m).cost;
        end
        fMax = max(victorPopulation);
        fMean = mean(victorPopulation);
        
        if PopulationCross(iii).cost >= fMean
            OPTIONS.popmute = 0.5 * ((fMax - PopulationCross(iii).cost) / (fMax - Population(iii).cost));
        else
            OPTIONS.popmute = 0.5;
        end
        
        popmu1 = Population(ma(i));
        popmu2 = PopulationPrevious1(ma(i));
        popmu3 = PopulationPrevious2(ma(i));
        
        delta = (popmu2.cost - popmu3.cost) * (popmu1.cost - popmu2.cost);
        if delta > 0
            for gen = 1 : OPTIONS.numVar
                condition = (popmu2.chrom(gen) - popmu3.chrom(gen)) * (popmu1.chrom(gen) - popmu2.chrom(gen));
                if condition > 0
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + sign(popmu1.cost - popmu2.cost) *...
                        (popmu1.chrom(gen) - popmu2.chrom(gen)) * OPTIONS.popmute;
                    continue;
                end
                if condition < 0
                    rs = -1 * (1 - (-1)) * rand;
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + abs((popmu1.chrom(gen) - popmu2.chrom(gen))) * ...
                        rs * OPTIONS.popmute;
                    continue;
                end
                if condition == 0
                    rs = -1 * (1 - (-1)) * rand;
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + popmu1.chrom(gen) * ...
                        rs * OPTIONS.popmute;
                    continue;
                end
            end
        end
        if delta < 0
            for gen = 1 : OPTIONS.numVar
                condition = (popmu2.chrom(gen) - popmu3.chrom(gen)) * (popmu1.chrom(gen) - popmu2.chrom(gen));
                if PopulationCross(iii).cost >= fMean
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + sign(popmu1.cost - popmu2.cost) *...
                        (popmu1.chrom(gen) - popmu2.chrom(gen)) * OPTIONS.popmute;
                    continue;
                end
                if PopulationCross(iii).cost < fMean && condition < 0
                    rs = -1 * (1 - (-1)) * rand;
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + abs((popmu1.chrom(gen) - popmu2.chrom(gen))) * ...
                        rs * OPTIONS.popmute;
                    continue;
                end
                if PopulationCross(iii).cost < fMean && condition == 0
                    rs = -1 * (1 - (-1)) * rand;
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + popmu1.chrom(gen) * ...
                        rs * OPTIONS.popmute;
                    continue;
                end
            end
        end
        if delta == 0
            condition1 = (popmu2.cost - popmu3.cost);
            condition2 = (popmu1.cost - popmu2.cost);
            for gen = 1 : OPTIONS.numVar
                if condition1 == 0 && condition2 ~=0
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + sign(popmu1.cost - popmu2.cost) *...
                        (popmu1.chrom(gen) - popmu2.chrom(gen)) * OPTIONS.popmute;
                    continue;
                end
                if condition1 ~= 0 && condition2 ==0
                    rs = -1 * (1 - (-1)) * rand;
                    PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + abs((popmu1.chrom(gen) - popmu2.chrom(gen))) * ...
                        rs * OPTIONS.popmute;
                    continue;
                end
                if condition1 == 0 && condition2 ==0
                    r = rand;
                    rs = -1 * (1 - (-1)) * rand;
                    if r < 0.5
                        PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + (OPTIONS.MaxDomain(1) - popmu1.chrom(gen)) * ...
                            rs * OPTIONS.popmute;
                    else
                        PopulationADM(k).chrom(gen) = popmu1.chrom(gen) + (popmu1.chrom(gen) - OPTIONS.MinDomain(1)) * ...
                            rs * OPTIONS.popmute;
                    end
                    continue;
                end
            end
        end
    end
    PopulationPrevious2 = PopulationPrevious1;
    PopulationPrevious1 = Population;
    
    PopulationADM = OPTIONS.CostFunction(PopulationADM, OPTIONS);
    Population = [PopulationDirect PopulationADM];
end

% ________________________________ Display ________________________________

figure(1)
plot(1 : iteration, BestArray);
xlabel('generation');ylabel('cost');

figure(2)
plot(1 : iteration, AverageArray, 'r');
xlabel('generation');ylabel('cost');
end


