function [InitFunction, CostFunction] = F6
InitFunction = @Init;
CostFunction = @Cost;
return
function [Population, OPTIONS] = Init(OPTIONS)

% _______________________ Initialize the population _______________________
if ~isfield(OPTIONS, 'MinDomain')
    OPTIONS.MinDomain = -5 * ones(1, OPTIONS.numVar);
end
if ~isfield(OPTIONS, 'MaxDomain')
    OPTIONS.MaxDomain = +5 * ones(1, OPTIONS.numVar);
end

Population = struct('chrom', cell([1 OPTIONS.popsize]), 'cost', cell([1 OPTIONS.popsize]));
for popindex = 1 : OPTIONS.popsize
    chrom = OPTIONS.MinDomain + (OPTIONS.MaxDomain - OPTIONS.MinDomain) .* rand(1,OPTIONS.numVar);
    Population(popindex).chrom = chrom;
end
return


function [Population] = Cost(Population, OPTIONS)
% _____________ Compute the cost of each member in Population ____________
p = length(Population(1).chrom);
for popindex = 1 : length(Population)
    sum2=0;     
    sum1=0;
    for i = 1 : p-1
        x = Population(popindex).chrom(i);
        x2 = Population(popindex).chrom(i+1);
        x3 = Population(popindex).chrom(p-1);
        sum1=sum1+((x-1)^2)*(1+((sin(3*pi*x2))^2))+((x3-1)^2)*(1+((sin(2*pi*x3))^2));
        
    end
    sum2=sum2+10*(sin(3*pi*x))^2+ sum1;
    Population(popindex).cost =(0.1*sum2);
end
return