function [InitFunction, CostFunction] = F7
InitFunction = @Init;
CostFunction = @Cost;
return
function [Population, OPTIONS] = Init(OPTIONS)

% _______________________ Initialize the population _______________________
if ~isfield(OPTIONS, 'MinDomain')
    OPTIONS.MinDomain = -5 * ones(1, OPTIONS.numVar);
end
if ~isfield(OPTIONS, 'MaxDomain')
    OPTIONS.MaxDomain = +5 * ones(1, OPTIONS.numVar);
end

Population = struct('chrom', cell([1 OPTIONS.popsize]), 'cost', cell([1 OPTIONS.popsize]));
for popindex = 1 : OPTIONS.popsize
    chrom = OPTIONS.MinDomain + (OPTIONS.MaxDomain - OPTIONS.MinDomain) .* rand(1,OPTIONS.numVar);
    Population(popindex).chrom = chrom;
end
return


function [Population] = Cost(Population, OPTIONS)
% _____________ Compute the cost of each member in Population ____________
p = length(Population(1).chrom);
for popindex = 1 : length(Population)
    sum2=0;     
    sum1=1;
    for i = 1 : p
        x = Population(popindex).chrom(i);
       sum1=sum1*x;
        sum2=sum2+((log(x-2))^2 + (log(10-x))^2);
        
    end
   
    Population(popindex).cost =-(sum1^0.2 - sum2);
end
return