function [InitFunction, CostFunction] = G8
InitFunction = @Init;
CostFunction = @Cost;
return
function [Population, OPTIONS] = Init(OPTIONS)

% _______________________ Initialize the population _______________________
if ~isfield(OPTIONS, 'MinDomain')
    OPTIONS.MinDomain = -4.91017 * ones(1, OPTIONS.numVar);
     OPTIONS.MinDomain2 = -5.7126* ones(1, OPTIONS.numVar);
end
if ~isfield(OPTIONS, 'MaxDomain')
    OPTIONS.MaxDomain = +5.0893 * ones(1, OPTIONS.numVar);
    OPTIONS.MaxDomain2 = +4.2874 * ones(1, OPTIONS.numVar);
end

Population = struct('chrom', cell([1 OPTIONS.popsize]), 'cost', cell([1 OPTIONS.popsize]));
for popindex = 1 : OPTIONS.popsize
    chrom1 = OPTIONS.MinDomain + (OPTIONS.MaxDomain - OPTIONS.MinDomain) .* rand(1,OPTIONS.numVar);
     chrom2 = OPTIONS.MinDomain2 + (OPTIONS.MaxDomain2 - OPTIONS.MinDomain2) .* rand(1,OPTIONS.numVar);
    Population(popindex).chrom = chrom1;
     Population(popindex).chrom = chrom2;
end
return


function [Population] = Cost(Population, OPTIONS)
% _____________ Compute the cost of each member in Population ____________
p = length(Population(1).chrom);
for popindex = 1 : length(Population)
    sum1=0;
    
    for i = 1 : p-1
        x1 = Population(popindex).chrom(i);
        x2 = Population(popindex).chrom(i+1);
        
        sum1 =sum1 + -4*(x1^2)+2.1*(x1^4)-(1/3)*(x1^6)-x1*x2+4*(x2^2)-4*(x2^4);
    end
      Population(popindex).cost =sum1;
end
return