function [InitFunction, CostFunction] = G8
InitFunction = @Init;
CostFunction = @Cost;
return
function [Population, OPTIONS] = Init(OPTIONS)

% _______________________ Initialize the population _______________________
if ~isfield(OPTIONS, 'MinDomain')
    OPTIONS.MinDomain = -98 * ones(1, OPTIONS.numVar);
end
if ~isfield(OPTIONS, 'MaxDomain')
    OPTIONS.MaxDomain = +34 * ones(1, OPTIONS.numVar);
end

Population = struct('chrom', cell([1 OPTIONS.popsize]), 'cost', cell([1 OPTIONS.popsize]));
for popindex = 1 : OPTIONS.popsize
    chrom = OPTIONS.MinDomain + (OPTIONS.MaxDomain - OPTIONS.MinDomain) .* rand(1,OPTIONS.numVar);
    Population(popindex).chrom = chrom;
end
return


function [Population] = Cost(Population, OPTIONS)
% _____________ Compute the cost of each member in Population ____________
p = length(Population(1).chrom);
for popindex = 1 : length(Population)
    sum1 = 0;
    sum2=0;
    a=[-32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32 -32 -16 0 16 32;
       -32 -32 -32 -32 -32  -16 -16 -16 -16 -16  0 0 0 0 0 16 16 16 16 16 32 32 32 32 32];
   
  
    for j = 1 : 25
        for i=1 :2 
        x = Population(popindex).chrom(i);
        sum2 = sum2+ ((x-a(i,j))^6);
        end
      sum1 = sum1 +1/(j+sum2);
    end
      Population(popindex).cost =((1/500) + sum1)^(-1);
end
return